diff -ruN vdr-1.5.0/shutdown.c vdr-1.5.1/shutdown.c
--- vdr-1.5.0/shutdown.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.1/shutdown.c	2007-02-24 18:24:11.000000000 +0100
@@ -0,0 +1,250 @@
+/*
+ * shutdown.c: Handling of shutdown and inactivity
+ *
+ * See the main source file 'vdr.c' for copyright information and
+ * how to reach the author.
+ *
+ * Original version written by Udo Richter <udo_richter@gmx.de>.
+ *
+ * $Id: shutdown.c 1.1 2007/02/24 17:24:11 kls Exp $
+ */
+
+#include "shutdown.h"
+#include <stdio.h>
+#include <stdlib.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include "channels.h"
+#include "config.h"
+#include "cutter.h"
+#include "i18n.h"
+#include "interface.h"
+#include "menu.h"
+#include "plugin.h"
+#include "timers.h"
+#include "tools.h"
+
+cShutdownHandler ShutdownHandler;
+
+cCountdown::cCountdown(void)
+{
+  timeout = 0;
+  counter = 0;
+  timedOut = false;
+  message = NULL;
+}
+
+void cCountdown::Start(const char *Message, int Seconds)
+{
+  timeout = time(NULL) + Seconds;
+  counter = -1;
+  timedOut = false;
+  message = Message;
+  Update();
+}
+
+void cCountdown::Cancel(void)
+{
+  if (timeout) {
+     timeout = 0;
+     timedOut = false;
+     Skins.Message(mtStatus, NULL);
+     }
+}
+
+bool cCountdown::Done(void)
+{
+  if (timedOut) {
+     Cancel();
+     return true;
+     }
+  return false;
+}
+
+bool cCountdown::Update(void)
+{
+  if (timeout) {
+     int NewCounter = (timeout - time(NULL) + 9) / 10;
+     if (NewCounter <= 0)
+        timedOut = true;
+     if (counter != NewCounter) {
+        counter = NewCounter;
+        char time[10];
+        snprintf(time, sizeof(time), "%d:%d0", counter > 0 ? counter / 6 : 0, counter > 0 ? counter % 6 : 0);
+        cString Message = cString::sprintf(message, time);
+        Skins.Message(mtStatus, Message);
+        return true;
+        }
+     }
+  return false;
+}
+
+cShutdownHandler::cShutdownHandler(void)
+{
+  activeTimeout = 0;
+  retry = 0;
+  shutdownCommand = NULL;
+  exitCode = -1;
+  emergencyExitRequested = false;
+}
+
+cShutdownHandler::~cShutdownHandler()
+{
+  free(shutdownCommand);
+}
+
+void cShutdownHandler::RequestEmergencyExit(void)
+{
+  esyslog("initiating emergency exit");
+  emergencyExitRequested = true;
+  Exit(1);
+}
+
+void cShutdownHandler::CheckManualStart(int ManualStart)
+{
+  time_t Delta = Setup.NextWakeupTime ? Setup.NextWakeupTime - time(NULL) : 0;
+
+  if (!Setup.NextWakeupTime || abs(Delta) > ManualStart) {
+     // Apparently the user started VDR manually
+     dsyslog("assuming manual start of VDR");
+     // Set inactive after MinUserInactivity
+     SetUserInactiveTimeout();
+     }
+  else
+     // Set inactive from now on
+     SetUserInactive();
+}
+
+void cShutdownHandler::SetShutdownCommand(const char *ShutdownCommand)
+{
+  free(shutdownCommand);
+  shutdownCommand = ShutdownCommand ? strdup(ShutdownCommand) : NULL;
+}
+
+void cShutdownHandler::CallShutdownCommand(time_t WakeupTime, int Channel, const char *File, bool UserShutdown)
+{
+  time_t Delta = WakeupTime ? WakeupTime - time(NULL) : 0;
+  cString cmd = cString::sprintf("%s %ld %ld %d \"%s\" %d", shutdownCommand, WakeupTime, Delta, Channel, *strescape(File, "\"$"), UserShutdown);
+  isyslog("executing '%s'", *cmd);
+  if (SystemExec(cmd, true) == 0)
+     Setup.NextWakeupTime = WakeupTime; // Remember this wakeup time for comparison on reboot
+}
+
+void cShutdownHandler::SetUserInactiveTimeout(int Seconds, bool Force)
+{
+  if (!Setup.MinUserInactivity && !Force) {
+     activeTimeout = 0;
+     return;
+     }
+  if (Seconds < 0)
+     Seconds = Setup.MinUserInactivity * 60;
+  activeTimeout = time(NULL) + Seconds;
+}
+
+bool cShutdownHandler::ConfirmShutdown(bool Interactive)
+{
+  if (!shutdownCommand) {
+     if (Interactive)
+        Skins.Message(mtError, tr("Can't shutdown - option '-s' not given!"));
+     return false;
+     }
+  if (cCutter::Active()) {
+     if (!Interactive || !Interface->Confirm(tr("Editing - shut down anyway?")))
+        return false;
+     }
+
+  cTimer *timer = Timers.GetNextActiveTimer();
+  time_t Next = timer ? timer->StartTime() : 0;
+  time_t Delta = timer ? Next - time(NULL) : 0;
+
+  if (cRecordControls::Active() || (Next && Delta <= 0)) {
+     // VPS recordings in timer end margin may cause Delta <= 0
+     if (!Interactive || !Interface->Confirm(tr("Recording - shut down anyway?")))
+        return false;
+     }
+  else if (Next && Delta <= Setup.MinEventTimeout * 60) {
+     // Timer within Min Event Timeout
+     if (!Interactive)
+        return false;
+     cString buf = cString::sprintf(tr("Recording in %ld minutes, shut down anyway?"), Delta / 60);
+     if (!Interface->Confirm(buf))
+        return false;
+     }
+
+  if (cPluginManager::Active(Interactive ? tr("shut down anyway?") : NULL))
+     return false;
+
+  cPlugin *Plugin = cPluginManager::GetNextWakeupPlugin();
+  Next = Plugin ? Plugin->WakeupTime() : 0;
+  Delta = Next ? Next - time(NULL) : 0;
+  if (Next && Delta <= Setup.MinEventTimeout * 60) {
+     // Plugin wakeup within Min Event Timeout
+     if (!Interactive)
+        return false;
+     cString buf = cString::sprintf(tr("Plugin %s wakes up in %ld min, continue?"), Plugin->Name(), Delta / 60);
+     if (!Interface->Confirm(buf))
+        return false;
+     }
+
+  return true;
+}
+
+bool cShutdownHandler::ConfirmRestart(bool Interactive)
+{
+  if (cCutter::Active()) {
+     if (!Interactive || !Interface->Confirm(tr("Editing - restart anyway?")))
+        return false;
+     }
+
+  cTimer *timer = Timers.GetNextActiveTimer();
+  time_t Next  = timer ? timer->StartTime() : 0;
+  time_t Delta = timer ? Next - time(NULL) : 0;
+
+  if (cRecordControls::Active() || (Next && Delta <= 0)) {
+     // VPS recordings in timer end margin may cause Delta <= 0
+     if (!Interactive || !Interface->Confirm(tr("Recording - restart anyway?")))
+        return false;
+     }
+
+  if (cPluginManager::Active(Interactive ? tr("restart anyway?") : NULL))
+     return false;
+
+  return true;
+}
+
+bool cShutdownHandler::DoShutdown(bool Force)
+{
+  time_t Now = time(NULL);
+  cTimer *timer = Timers.GetNextActiveTimer();
+  cPlugin *Plugin = cPluginManager::GetNextWakeupPlugin();
+
+  time_t Next = timer ? timer->StartTime() : 0;
+  time_t NextPlugin = Plugin ? Plugin->WakeupTime() : 0;
+  if (NextPlugin && (!Next || Next > NextPlugin)) {
+     Next = NextPlugin;
+     timer = NULL;
+     }
+  time_t Delta = Next ? Next - Now : 0;
+
+  if (Next && Delta < Setup.MinEventTimeout * 60) {
+     if (!Force)
+        return false;
+     Delta = Setup.MinEventTimeout * 60;
+     Next = Now + Delta;
+     timer = NULL;
+     dsyslog("reboot at %s", *TimeToString(Next));
+     }
+
+  if (Next && timer) {
+     dsyslog("next timer event at %s", *TimeToString(Next));
+     CallShutdownCommand(Next, timer->Channel()->Number(), timer->File(), Force);
+     }
+  else if (Next && Plugin) {
+     CallShutdownCommand(Next, 0, Plugin->Name(), Force);
+     dsyslog("next plugin wakeup at %s", *TimeToString(Next));
+     }
+  else
+     CallShutdownCommand(Next, 0, "", Force); // Next should always be 0 here. Just for safety, pass it.
+
+  return true;
+}
diff -ruN vdr-1.5.0/shutdown.h vdr-1.5.1/shutdown.h
--- vdr-1.5.0/shutdown.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.5.1/shutdown.h	2007-02-24 18:23:59.000000000 +0100
@@ -0,0 +1,112 @@
+/*
+ * shutdown.h: Handling of shutdown and inactivity
+ *
+ * See the main source file 'vdr.c' for copyright information and
+ * how to reach the author.
+ *
+ * Original version written by Udo Richter <udo_richter@gmx.de>.
+ *
+ * $Id: shutdown.h 1.1 2007/02/24 17:23:59 kls Exp $
+ */
+
+#ifndef __SHUTDOWN_H
+#define __SHUTDOWN_H
+
+#include <time.h>
+
+class cCountdown {
+private:
+  time_t timeout;      ///< 5-minute countdown timer
+  int counter;         ///< last shown time in 10s units
+  bool timedOut;       ///< countdown did run down to 0 and was not canceled
+  const char *message; ///< message to display, %s is placeholder for time
+public:
+  cCountdown(void);
+  void Start(const char *Message, int Seconds);
+       ///< Start the 5 minute shutdown warning countdown.
+  void Cancel(void);
+       ///< Cancel the 5 minute shutdown warning countdown.
+  bool Done(void);
+       ///< Check if countdown timer has run out without canceling.
+  operator bool(void) const { return timeout != 0; }
+       ///< Check if countdown is running.
+  bool Update(void);
+       ///< Update status display of the countdown.
+       ///< Returns true on actual update.
+  };
+
+class cShutdownHandler {
+private:
+  time_t activeTimeout;
+       ///< Time when VDR will become non-interactive. 0 means never.
+  time_t retry;
+       ///< Time for retrying the shutdown.
+  char *shutdownCommand;
+       ///< Command for shutting down VDR.
+  int exitCode;
+       ///< Exit code, if VDR exit was requested, or -1 if not requested.
+  bool emergencyExitRequested;
+       ///< The requested exit is an emergency exit.
+public:
+  cCountdown countdown;
+  cShutdownHandler(void);
+  ~cShutdownHandler();
+  void Exit(int ExitCode) { exitCode = ExitCode; }
+       ///< Set VDR exit code and initiate end of VDR main loop.
+       ///< This will exit VDR without any confirmation.
+  bool DoExit(void) { return exitCode >= 0; }
+       ///< Check if an exit code was set, and VDR should exit.
+  int GetExitCode(void) { return exitCode >= 0 ? exitCode : 0; }
+       ///< Get the currently set exit code of VDR.
+  bool EmergencyExitRequested(void) { return emergencyExitRequested; }
+       ///< Returns true if an emergency exit was requested.
+  void RequestEmergencyExit(void);
+       ///< Requests an emergency exit of the VDR main loop.
+  void CheckManualStart(int ManualStart);
+       ///< Check whether the next timer is in ManualStart time window.
+       ///< If yes, assume non-interactive use.
+  void SetShutdownCommand(const char *ShutdownCommand);
+       ///< Set the command string for shutdown command.
+  void CallShutdownCommand(time_t WakeupTime, int Channel, const char *File, bool UserShutdown);
+       ///< Call the shutdown command with the given parameters.
+  bool IsUserInactive(time_t AtTime = 0) { return activeTimeout && activeTimeout <= (AtTime ? AtTime : time(NULL)); }
+       ///< Check whether VDR is in interactive mode or non-interactive mode (waiting for shutdown).
+       ///< AtTime checks whether VDR will probably be inactive at that time.
+  time_t GetUserInactiveTime(void) { return activeTimeout; }
+       ///< Time when user will become non-inactive, or 0 if never.
+  void SetUserInactiveTimeout(int Seconds = -1, bool Force = false);
+       ///< Set the time when VDR will switch into non-interactive mode or power down.
+       ///< -1 means Setup.MinUserInactivity in the future.
+       ///< Otherwise, seconds in the future.
+       ///< If MinUserInactivity = 0 and Force = false, Seconds is ignored and VDR will
+       ///< stay interactive forever.
+  void SetUserInactive(void) { SetUserInactiveTimeout(0, true); }
+       ///< Set VDR manually into non-interactive mode.
+  bool Retry(time_t AtTime = 0) { return retry <= (AtTime ? AtTime : time(NULL)); }
+       ///< Check whether its time to re-try the shutdown.
+       ///< AtTime checks whether VDR will probably be inactive at that time.
+  time_t GetRetry(void) { return retry; }
+       ///< Time when shutdown retry block ends.
+  void SetRetry(int Seconds) { retry = time(NULL) + Seconds; }
+       ///< Set shutdown retry so that VDR will not try to automatically shut down
+       ///< within Seconds.
+  bool ConfirmShutdown(bool Ask);
+       ///< Check for background activity that blocks shutdown.
+       ///< Returns immediately and without user interaction if Ask = false.
+       ///< Asks for confirmation if Ask = true.
+       ///< Returns true if ready for shutdown.
+  bool ConfirmRestart(bool Ask);
+       ///< Check for background activity that blocks restart.
+       ///< Returns immediately and without user interaction if Ask = false.
+       ///< Asks for confirmation if Ask = true.
+       ///< Returns true if ready for restart.
+  bool DoShutdown(bool Force);
+       ///< Call the shutdown script with data of the next pending timer.
+       ///< Fails if Force = false and a timer is running or within MinEventTimeout.
+       ///< Always calls shutdown on Force = true.
+       ///< Returns true on success.
+  };
+
+extern cShutdownHandler ShutdownHandler;
+
+#endif
diff -ruN vdr-1.5.0/sources.conf vdr-1.5.1/sources.conf
--- vdr-1.5.0/sources.conf	2006-06-15 12:02:28.000000000 +0200
+++ vdr-1.5.1/sources.conf	2007-02-17 17:15:13.000000000 +0100
@@ -38,7 +38,7 @@
 S39E    Hellas Sat 2
 S40E    Express AM1
 S42E    Turksat 1C/2A
-S45E    PAS 12
+S45E    Intelsat 12
 S49E    Yamal 202
 S53E    Express AM 22
 S55E    Insat 3E & Intelsat 702
@@ -48,9 +48,9 @@
 S62E    Intelsat 902
 S64E    Intelsat 906
 S66E    Intelsat 704
-S68.5E  PAS 7/10
+S68.5E  Intelsat 7/10
 S70.5E  Eutelsat W5
-S72E    PAS 4
+S72E    Intelsat 4
 
 # Asia
 
@@ -98,8 +98,8 @@
 S160E   Optus B1
 S162E   Superbird B2
 S164E   Optus A3
-S166E   PAS 8
-S169E   PAS 2
+S166E   Intelsat 8
+S169E   Intelsat 2
 S172E   AMC 23
 S180E   Intelsat 701
 S177W   NSS 5
@@ -125,12 +125,12 @@
 S34.5W  Intelsat 903
 S37.5W  Telstar 11 & AMC 12
 S40.5W  NSS 806
-S43W    PAS 3R/6B
-S45W    PAS 1R
+S43W    Intelsat 3R/6B
+S45W    Intelsat 1R
 S50W    Intelsat 705
 S53W    Intelsat 707
 S55.5W  Intelsat 805
-S58W    PAS 9
+S58W    Intelsat 9
 S61W    Amazonas
 
 # America
@@ -151,13 +151,13 @@
 S85W    AMC 2
 S85.1W  XM 3
 S87W    AMC3
-S89W    Intelsat Americas 8
+S89W    Galaxy 28
 S91W    Galaxy 11 & Nimiq 1
 S91.5W  DirecTV 2
 S92W    Brasilsat B4
-S93W    Intelsat Americas 6
+S93W    Galaxy 26
 S95W    Galaxy 3C
-S97W    Intelsat Americas 5
+S97W    Galaxy 25
 S99W    Galaxy 4R
 S99.2W  Spaceway 2
 S101W   DirecTV 1R/4S/8 & AMC4
@@ -168,11 +168,11 @@
 S111.1W Anik F2
 S113W   Solidaridad 2
 S119W   Echostar 7 & DirecTV 7S
-S121W   Echostar 9 & Intelsat Americas 13
+S121W   Echostar 9 & Galaxy 23
 S123W   Galaxy 10R
 S125W   Galaxy 14
 S127W   Galaxy 13/Horizons 1
-S129W   Echostar 5 & Intelsat Americas 7
+S129W   Echostar 5 & Galaxy 27
 S131W   AMC 11
 S133W   Galaxy15/1R
 S135W   AMC 10
diff -ruN vdr-1.5.0/thread.c vdr-1.5.1/thread.c
--- vdr-1.5.0/thread.c	2007-01-05 11:44:22.000000000 +0100
+++ vdr-1.5.1/thread.c	2007-02-24 17:13:33.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.c 1.59 2007/01/05 10:44:22 kls Exp $
+ * $Id: thread.c 1.60 2007/02/24 16:13:33 kls Exp $
  */
 
 #include "thread.h"
@@ -200,7 +200,6 @@
 // --- cThread ---------------------------------------------------------------
 
 tThreadId cThread::mainThreadId = 0;
-bool cThread::emergencyExitRequested = false;
 
 cThread::cThread(const char *Description)
 {
@@ -320,14 +319,6 @@
      }
 }
 
-bool cThread::EmergencyExit(bool Request)
-{
-  if (!Request)
-     return emergencyExitRequested;
-  esyslog("initiating emergency exit");
-  return emergencyExitRequested = true; // yes, it's an assignment, not a comparison!
-}
-
 tThreadId cThread::ThreadId(void)
 {
   return syscall(__NR_gettid);
@@ -505,7 +496,7 @@
 
 // --- SystemExec ------------------------------------------------------------
 
-int SystemExec(const char *Command)
+int SystemExec(const char *Command, bool Detached)
 {
   pid_t pid;
 
@@ -515,14 +506,24 @@
      }
 
   if (pid > 0) { // parent process
-     int status;
-     if (waitpid(pid, &status, 0) < 0) {
+     int status = 0;
+     if (!Detached && waitpid(pid, &status, 0) < 0) {
         LOG_ERROR;
         return -1;
         }
      return status;
      }
   else { // child process
+     if (Detached) {
+        // Start a new session
+        pid_t sid = setsid();
+        if (sid < 0)
+           LOG_ERROR;
+        // close STDIN and re-open as /dev/null
+        int devnull = open("/dev/null", O_RDONLY);
+        if (devnull < 0 || dup2(devnull, 0) < 0)
+           LOG_ERROR;
+        }
      int MaxPossibleFileDescriptors = getdtablesize();
      for (int i = STDERR_FILENO + 1; i < MaxPossibleFileDescriptors; i++)
          close(i); //close all dup'ed filedescriptors
diff -ruN vdr-1.5.0/thread.h vdr-1.5.1/thread.h
--- vdr-1.5.0/thread.h	2007-01-05 11:44:38.000000000 +0100
+++ vdr-1.5.1/thread.h	2007-02-24 17:13:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.h 1.38 2007/01/05 10:44:38 kls Exp $
+ * $Id: thread.h 1.39 2007/02/24 16:13:28 kls Exp $
  */
 
 #ifndef __THREAD_H
@@ -84,7 +84,6 @@
   cMutex mutex;
   char *description;
   static tThreadId mainThreadId;
-  static bool emergencyExitRequested;
   static void *StartThread(cThread *Thread);
 protected:
   void SetPriority(int Priority);
@@ -118,7 +117,6 @@
        ///< If the thread is already running, nothing happens.
   bool Active(void);
        ///< Checks whether the thread is still alive.
-  static bool EmergencyExit(bool Request = false);
   static tThreadId ThreadId(void);
   static tThreadId IsMainThread(void) { return ThreadId() == mainThreadId; }
   static void SetMainThreadId(void);
@@ -175,7 +173,9 @@
 
 // SystemExec() implements a 'system()' call that closes all unnecessary file
 // descriptors in the child process.
+// With Detached=true, calls command in background and in a separate session,
+// with stdin connected to /dev/null.
 
-int SystemExec(const char *Command);
+int SystemExec(const char *Command, bool Detached = false);
 
 #endif //__THREAD_H
